dofile("./map.lua")

function drawMap()
   for y = yTile1,yTile2 do
      for x = xTile1,xTile2 do
          if myMap[y][x].bg > 0 then
              screen:blit((x - 1) * TILESIZE - HscrollValue, (y - 1) * TILESIZE - VscrollValue,Tiles[myMap[y][x].bg])
          end
          if myMap[y][x].ob > 0 then
              screen:blit((x - 1) * TILESIZE - HscrollValue, (y - 1) * TILESIZE - VscrollValue,Tiles[myMap[y][x].ob])
          end
          if myMap[y][x].fg > 0 then
              screen:blit((x - 1) * TILESIZE - HscrollValue, (y - 1) * TILESIZE - VscrollValue,Tiles[myMap[y][x].fg])
          end
      end
  end
end

function buttonInput()
  pad = Controls.read()
  if pad:left() and HscrollValue > 0 then
      HscrollValue = HscrollValue - 1
  end

  if pad:right() and HscrollValue < maxHscrollValue then
      HscrollValue = HscrollValue + 1
  end

  if pad:up() and VscrollValue > 0 then
      VscrollValue = VscrollValue - 1
  end

  if pad:down() and VscrollValue < maxVscrollValue then
      VscrollValue = VscrollValue + 1
  end
end

function getScreenTiles()
  xTile1 = math.floor(HscrollValue / TILESIZE + 1)
  xTile2 = math.floor((HscrollValue / TILESIZE + 1) + (ScreenResW / TILESIZE))
  yTile1 = math.floor(VscrollValue / TILESIZE + 1)
  yTile2 = math.floor((VscrollValue / TILESIZE + 1) + (ScreenResH / TILESIZE))
  if xTile2 > mapWidth then xTile2 = mapWidth end
  if yTile2 > mapHeight then yTile2 = mapHeight end
end

--------MAIN LOOP---------

while true do

screen:clear()

buttonInput()

getScreenTiles()

drawMap()

screen.waitVblankStart()

screen.flip()

end
